/* PowePC 970 gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 1995, 1999, 2000, 2001, 2002 Free Software
Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with the GNU MP Library; see the file COPYING.LIB.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
MA 02111-1307, USA. */

#define BITS_PER_MP_LIMB 64
#define BYTES_PER_MP_LIMB 8

/* Generated by tuneup.c, 2005-03-03, gcc 4.0 */

#define MUL_KARATSUBA_THRESHOLD          16
#define MUL_TOOM3_THRESHOLD             117

#define SQR_BASECASE_THRESHOLD            4
#define SQR_KARATSUBA_THRESHOLD          30
#define SQR_TOOM3_THRESHOLD             186

#define DIV_SB_PREINV_THRESHOLD           0  /* always */
#define DIV_DC_THRESHOLD                 26
#define POWM_THRESHOLD                   97

#define GCD_ACCEL_THRESHOLD               3
#define GCDEXT_THRESHOLD                  0  /* always */
#define JACOBI_BASE_METHOD                1

#define DIVREM_1_NORM_THRESHOLD           0  /* always */
#define DIVREM_1_UNNORM_THRESHOLD         0  /* always */
#define MOD_1_NORM_THRESHOLD              0  /* always */
#define MOD_1_UNNORM_THRESHOLD            0  /* always */
#define USE_PREINV_DIVREM_1               1
#define USE_PREINV_MOD_1                  1
#define DIVREM_2_THRESHOLD                0  /* always */
#define DIVEXACT_1_THRESHOLD              0  /* always */
#define MODEXACT_1_ODD_THRESHOLD          0  /* always */

#define GET_STR_DC_THRESHOLD             13
#define GET_STR_PRECOMPUTE_THRESHOLD     20
#define SET_STR_THRESHOLD              6336

#define MUL_FFT_TABLE  { 560, 1184, 2624, 4864, 13312, 36864, 0 }
#define MUL_FFT_MODF_THRESHOLD          576
#define MUL_FFT_THRESHOLD              4224

#define SQR_FFT_TABLE  { 592, 1312, 2880, 5376, 13312, 36864, 0 }
#define SQR_FFT_MODF_THRESHOLD          608
#define SQR_FFT_THRESHOLD              3968

/* Tuneup completed successfully, took 17 seconds */

/* The following flags would normally get set by configure, but 
   .asm routines don't link (?) correctly in Apple's gcc4.0 (yet). 
   Fortunately, C wrappers on asm blocks work OK. PBM 3 March 05 */
#define HAVE_NATIVE_mpn_add_n 1
#define HAVE_NATIVE_mpn_addmul_1 1
#define HAVE_NATIVE_mpn_addmul_1c 1
#define HAVE_NATIVE_mpn_lshift 1
#define HAVE_NATIVE_mpn_mul_1 1
#define HAVE_NATIVE_mpn_mul_1c 1
#define HAVE_NATIVE_mpn_rshift 1
#define HAVE_NATIVE_mpn_sqr_diagonal 1
#define HAVE_NATIVE_mpn_sub_n 1
#define HAVE_NATIVE_mpn_submul_1 1
#define HAVE_NATIVE_mpn_submul_1c 1



